# this file is included by the various compile scripts.
# here you can change settings to reflect your system.
# the script will be read by the "bash" shell.

set -e



# choose one of the following settings, or define your own one.

# --- debug, noopt
#C="-O0 -g"
#L="-g"

# --- debug, profile, noopt
#C="-O0 -g -pg"
#L="-g -pg"

# --- superopt with debug
#C="-O2 -g"
#L="-g"

# --- superopt
C="-O2"
L="-s"



# options that shall always be there:
C="$C -Wall -Werror"

# libs - redefine those variables to suit your system!
CSIG="$(sigc-config --cflags)"
LSIG="$(sigc-config --libs)"



# change those functions to reflect your needs.

# the c++ compiler.
function CXX
{
    echo "g++ $@"
    g++ "$@"
}

# you need m4 in order to create the source files.
function M4
{
    echo "m4 $1 > $2"
    m4 "$1" > "$2"
}
