#include "messages.hpp"

#include "yyysendables.hpp"

using namespace yyybinbuff;

void appendtobinbuffer (const cell &a, binbuff &b)
{
  appendtobinbuffer(a.ascii,b);
  appendtobinbuffer(a.colnum,b);
};

const binbuff::index readfrombinbuffer (cell &a, const binbuff &b, const binbuff::index pos)
{
  binbuff::index read, mypos=pos;

  read=readfrombinbuffer(a.ascii,b,mypos);
  if (read<0) return read;
  mypos+=read;

  read=readfrombinbuffer(a.colnum,b,mypos);
  if (read<0) return read;
  mypos+=read;

  return mypos-pos;
};


void appendtobinbuffer (const tempm_cell &a, yyybinbuff::binbuff &b)
{
  appendtobinbuffer (a.xsize(), b);
  appendtobinbuffer (a.ysize(), b);
  for (tempm_cell::index_t y=0;y<a.ysize();++y)
    for (tempm_cell::index_t x=0;x<a.xsize();++x)
      appendtobinbuffer (a(x,y), b);
};

const yyybinbuff::binbuff::index readfrombinbuffer (tempm_cell &a, const yyybinbuff::binbuff &b, const yyybinbuff::binbuff::index pos)
{
  binbuff::index read, mypos=pos;
  
  tempm_cell::index_t xs, ys;

  read=readfrombinbuffer(xs,b,mypos);
  if (read<0) return read;
  mypos+=read;

  read=readfrombinbuffer(ys,b,mypos);
  if (read<0) return read;
  mypos+=read;

  if (b.size()-mypos<xs*ys) return -1;
  // FIXME that's ultra performance quick hack but dangerous if cell
  // encoding size changes!

  a.resize(xs,ys);

  for (tempm_cell::index_t y=0;y<a.ysize();++y)
    for (tempm_cell::index_t x=0;x<a.xsize();++x) {
      read=readfrombinbuffer(a(x,y),b,mypos);
      if (read<0) return read;
      mypos+=read;
    };

  return mypos-pos;
};


void appendtobinbuffer (const MSG_cc &a, binbuff &b)
{
  appendtobinbuffer(a.x,b);
  appendtobinbuffer(a.y,b);
  appendtobinbuffer(a.cl,b);
};

const binbuff::index readfrombinbuffer
(MSG_cc &a, const binbuff &b,
 const binbuff::index pos)
{
  binbuff::index read, mypos=pos;

  read=readfrombinbuffer(a.x,b,mypos);
  if (read<0) return read;
  mypos+=read;
  
  read=readfrombinbuffer(a.y,b,mypos);
  if (read<0) return read;
  mypos+=read;
  
  read=readfrombinbuffer(a.cl,b,mypos);
  if (read<0) return read;
  mypos+=read;

  return mypos-pos;
};
