/*

  yyybinbuff - a implementation of the binbuffer concept
  Copyright (C) 2000  Erik Thiele

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#ifndef __YYYBINBUFF_HPP
#define __YYYBINBUFF_HPP

#include "binarydefs.hpp"

#include <vector>

namespace yyybinbuff {

  // binbuffer is a model of the binbuffer concept
  class binbuff {
  public:
    typedef int32 index;
    inline const uint8 & operator [] (const index x) const { return rep[x]; };
    inline uint8 & operator [] (const index x) { return rep[x]; };
    inline const index size() const { return rep.size(); };
    inline void resize (const index s) { rep.resize(s); };
    inline void erase (const index first, const index last) { rep.erase(&rep[first], &rep[last]); };
  private:
    vector<uint8> rep;
  };

};

#endif
